package com.zt.plat.module.contractorder.service.salesorder;

import java.util.*;

import com.zt.plat.module.contractorder.controller.admin.purchaseorder.vo.*;
import com.zt.plat.module.contractorder.controller.admin.salesorder.vo.SalesOrderPageReqVO;
import com.zt.plat.module.contractorder.controller.admin.salesorder.vo.SalesOrderRespVO;
import com.zt.plat.module.contractorder.controller.admin.salesorder.vo.SalesOrderReviewReqVO;
import com.zt.plat.module.contractorder.controller.admin.salesorder.vo.SalesOrderSaveReqVO;
import com.zt.plat.module.contractorder.dal.dataobject.salesorder.SalesOrderDO;
import jakarta.validation.*;

import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 采购订单 Service 接口
 *
 * @author 后台管理-1
 */
public interface SalesOrderService {

    /**
     * 创建采购订单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    SalesOrderRespVO createSalesOrder(@Valid SalesOrderSaveReqVO createReqVO);

    /**
     * 更新采购订单
     *
     * @param updateReqVO 更新信息
     */
    void updateSalesOrder(@Valid SalesOrderSaveReqVO updateReqVO);

    /**
     * 删除采购订单
     *
     * @param id 编号
     */
    void deleteSalesOrder(Long id);

    /**
    * 批量删除采购订单
    *
    * @param ids 编号
    */
    void deleteSalesOrderListByIds(List<Long> ids);

    /**
     * 获得采购订单
     *
     * @param id 编号
     * @return 采购订单
     */
    SalesOrderDO getSalesOrder(Long id, String splyBsnTp);

    /**
     * 获得采购订单分页
     *
     * @param pageReqVO 分页查询
     * @return 采购订单分页
     */
    PageResult<SalesOrderDO> getSalesOrderPage(SalesOrderPageReqVO pageReqVO);
    /**
     * 设置采购订单详情
     *
     * @param salesOrderRespVO 采购订单
     */
    void setSalesOrderDetail(SalesOrderRespVO salesOrderRespVO);
    /**
     * 推送ERP
     *
     * @param orderId 订单编号
     * @return 是否成功
     */
    boolean pushErp091(String orderId);
    /**
     * 提交审批
     *
     * @param orderId 订单编号
     * @return String
     */
    String submitOrder(String orderId);

    /**
     * 订单审核通过和不通过
     *
     * @param salesOrderReviewReqVO 采购审核
     *
     */
    boolean orderPassReject(SalesOrderReviewReqVO salesOrderReviewReqVO);
    /**
     * 消费订单关联采购订单
     *
     * @param reqVO 采购订单
     *
     */
    boolean  linkOrder(LinkOrderReqVO reqVO);
    /**
     * 获取消费订单详情
     *
     * @param reqVO 采购订单
     *
     */

    List<DownOrUpOrderRespVO> getOrderByOrderIdAndType(DownOrUpOrderReqVO reqVO);
    /**
     * 获取已绑定消费订单详情
     *
     * @param reqVO 采购订单
     *
     */

    List<PurchaseOrderRespVO> getBindOrderByOrder(DownOrUpOrderReqVO reqVO);
    /**
     * 修改订单状态
     *
     * @param req 采购订单
     *
     */
   void updateOrderStatusByIdOrOrderNo(OrderStsReqVO req);
   /**
     * 获取订单详情
     *
     * @param orderNo 订单编号
     *
     */
    SalesOrderDO getSalesOrderByOrderNo(String orderNo);
    /**
     * 提交erp092
     *
     * @param orderId 销售订单更新请求erp
     *
     */
//    void submitErpUpdate092(String orderId);
}
